#include <sys/types.h>
#include <sys/param.h>
#include <sys/module.h>
#include <sys/kernel.h>

#include "cd9660_uni2asc.h"
#include "ctable.h"

extern u_char (*cd9660_wchar2char)(u_int32_t wchar);

static u_char do_convert(u_int32_t wchar);

static int
mod_load(struct module *module, int cmd, void *arg)
{
	int error = 0;

	switch (cmd) {
	case MOD_LOAD:
		cd9660_wchar2char = do_convert;
		break;
	case MOD_UNLOAD:
		cd9660_wchar2char = NULL;
		break;
	default:
		error = EINVAL;
		break;
	}
	return error;
}

static u_char
do_convert(u_int32_t wchar)
{
	u_char schar;
	int i;

	schar = '?';
	for (i = 0; i < 256; i++)
		if (ctable[i] == wchar) {
			schar = i;
			break;
		}

	return schar;
}

